// stack_vec_poin_off.cc

#include <forint/stack_vec_poin_off.hh>

namespace FInt {

ostream& operator << (ostream& out, const poin_t& p)
{
  out << '\'' << p.poin_type << "\', " << p.num_dims;
  return out;
}

ostream& operator << (ostream& out, const action_t& a)
{
  out << uint(a);
  return out;
}

ostream& operator << (ostream& out, const offsets_t& p)
{
  out << '\n' << ' ' << p.ra
      << ' ' << p.sa
      << ' ' << p.num
      << ' ' << p.var
      << ' ' << p.poin
      << ' ' << p.poin_level
      << ' ' << p.func0
      << ' ' << p.func1
      << ' ' << p.func2d
      << ' ' << p.func2p
      << ' ' << p.func2
      << ' ' << p.offsets;
  return out;
}

template<class T>
void stack_t<T>::
show(void)
{
  if (!lim) return;
  uint s = last+1;
  T* p = ptr;
  while (s--) cout << (*p++) << ' ';
}
template void stack_t<double>::show(void);
template void stack_t<uint>::show(void);
template void stack_t<offsets_t>::show(void);

template<class T>
void vec_t<T>::
show(void)
{
  if (!lim) return;
  uint s = last+1;
  T* p = ptr;
  while (s--) cout << (*p++) << ' ';
}
template void vec_t<double>::show(void);
template void vec_t<uint>::show(void);
template void vec_t<offsets_t>::show(void);

}
